#pragma once

#define RVLVS_ERR_CAMERA		0x01000000
#define RVLVS_ERR_EDGE_MAP_FILE	0x02000000

#define RVLSYS_FLAGS_IMAGE							0x00000001
#define RVLSYS_FLAGS_WARP_IMAGE						0x00000002
#define RVLSYS_FLAGS_STEREO							0x00000004
#define RVLSYS_FLAGS_KINECT							0x00000008
#define RVLSYS_FLAGS_PC								0x00000010
#define RVLSYS_FLAGS_PCLPCD							0x00000020
#define RVLSYS_FLAGS_USE_SEQUENCE_FILE				0x00000040
#define RVLSYS_FLAGS_BEST_SUBSET_HYPOTHESIS			0x00000080

#define RVLSYS_FLAGS2_STEREO_ROI					0x00000001


#define RVLSYS_MCMEMSIZE		2

//#define RVLSYS_PSULMBRLM_UPDATE_LOG_FILE

struct RVLLIDAR_PARAMS
{
	double minTilt;
	double maxTilt;
	double dTilt;
	int nPanIn120deg;
	double scale;
};

class CRVLVisionSystem
{
public:
	DWORD m_Flags, m_Flags2;
	CRVLMem m_Mem0, m_Mem, m_Mem2, m_MCMem[RVLSYS_MCMEMSIZE];
	int m_iMCMem;
	CRVLCamera m_CameraL, m_CameraR;
	CRVLAImage m_AImage;
	RVLRECT m_ROI;
	CRVLStereoVision m_StereoVision;
	CRVLTimer *m_pTimer;
	char *m_ImageFileName;
	char *m_SequenceFileName;
	CRVLKinect m_Kinect;
	int m_Mem0Size;
	int m_MemSize;
	int m_Mem2Size;
	int m_MCMemSize;
	CRVLParameterList m_ParamList;
	CRVLMem m_ParamMem;
	int m_nPC;
	double *m_PC;
	RVLLIDAR_PARAMS m_LidarParams;
	int m_SampleStep;

public:
	CRVLVisionSystem();
	virtual ~CRVLVisionSystem();
	DWORD Init(char *CfgFile2Name = NULL);
	void Clear();
	void UpdateMem();
	virtual BOOL RealTimeDisplay(CRVLGUI *pGUI);
	virtual void CreateParamList();	
	virtual bool InputRGBDImageFromFile(
		RVLDISPARITYMAP *DepthImage,
		IplImage *pRGBImage,
		char *RGBExtension,
		char *pDepthExtension);
	void SaveRGBDImageToFile(
		RVLDISPARITYMAP *pDepthImage,
		IplImage *pRGBImage,
		char *RGBExtension);
	void SavePC();
	void GetOrgPCProjectionSize();
};
